import junit.framework.*;

public class TestMM extends TestCase
{
    private Code        code        = new Code();
    private Code        code2       = new Code();
    private Menu        menu        = new Menu();
    private CodeMaker   codeMaker   = new CodeMaker(10);
    private CodeBreaker codeBreaker = new CodeBreaker(10);

    public TestMM(String name)
    {
        super(name);
    }

    public void testTest1()
    {
        /*************** Test Code Class ***************/
        //Test Code()
        //Defaults the code to "1111"
         assertEquals("TEST 1 FAILED", code.toString(), "1111");

        //Test makeCode()
        //Test that the codes are random
        code.makeCode();
        String temp  = code.toString();
        code.makeCode();
        String temp2 = code.toString();
        assertFalse("TEST 2 FAILED", temp.equals(temp2));

        //Test setCode()
        //Test that the code is set
        code.setCode("1234");
        assertEquals("TEST 3 FAILED", "1234", code.toString());

        //Test increment()
        //Test that the code is incremented
        //code is 1234 --> 1235
        code.increment();
        assertEquals("TEST 4 FAILED", "1235", code.toString());

        //Test score()
        //Test that score returns the right score
        //code is 1235
        code2.setCode("1235");
        assertEquals("TEST 5 FAILED", 40, code.score(code2));
        code2.setCode("5321");
        assertEquals("TEST 6 FAILED", 4,  code.score(code2));
        code2.setCode("0000");
        assertEquals("TEST 7 FAILED", 0,  code.score(code2));

        //Test getColors()
        //Test that score returns the # of different colors in a code
        code.setCode("1234");
        assertEquals("TEST 8 FAILED",  4, code.getColors());
        code.setCode("1233");
        assertEquals("TEST 9 FAILED",  3, code.getColors());
        code.setCode("1222");
        assertEquals("TEST 10 FAILED", 2, code.getColors());
        code.setCode("1111");
        assertEquals("TEST 11 FAILED", 1, code.getColors());

        //Test toString()
        //Test that the code that is set is returned in the string
        code.setCode("4321");
        assertEquals("TEST 12 FAILED", "4321", code.toString());

        //Test wrapped()
        //It should return false
        assertFalse("TEST 13 FAILED", code.wrapped());

        /*************** Test CodeBreaker Class ***************/

        //Test CodeBreaker() & setCode() & takeTurn()
        //It should retun  a string of length 4
        assertEquals("TEST 14 FAILED", 4,
                     codeBreaker.takeTurn("00").length());

        /*************** Test CodeMaker Class ***************/

        //Test CodeMaker() && setCode() && takeTurn() && secretCode()
        //Compair the score give when the secret code is compaired to
        //its self
        temp = new String();
        temp = codeMaker.secretCode();
        assertEquals("TEST 15 FAILED", "40", codeMaker.takeTurn(temp));

        /*************** Test Player Class ***************/

        //Test getMaxTries()
        //It should return 10
        assertEquals("TEST 16 FAILED", 10, codeMaker.getMaxTries());
        assertEquals("TEST 17 FAILED", 10, codeMaker.getMaxTries());

        /*************** Test Menu Class ***************/

        //Test getChoice() && addOption()
        //Test that it return 5
        int choice = 0;
        menu.addOption("1");
        menu.addOption("2");
        menu.addOption("3");
        menu.addOption("4");
        menu.addOption("5");
        try
        {
            choice = menu.getChoice();
        }
        catch(Exception e) {}
        assertEquals("TEST 18 FAILED", 5, choice);
     }
}
